RequestDispatcher (Servlet 4.0 API Documentation - Apache Tomcat 9.0.71)

Package javax.servlet

## Interface RequestDispatcher

-     public interface RequestDispatcher

  Defines an object that receives requests from the client and sends them to any resource (such as a servlet, HTML file, or JSP file) on the server. The servlet container creates the `RequestDispatcher` object, which is used as a wrapper around a server resource located at a particular path or given by a particular name.

  This interface is intended to wrap servlets, but a servlet container can create `RequestDispatcher` objects to wrap any type of resource.

  See Also:
    `ServletContext.getRequestDispatcher(java.lang.String)`, `ServletContext.getNamedDispatcher(java.lang.String)`, `ServletRequest.getRequestDispatcher(java.lang.String)`

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.lang.String` | `ERROR_EXCEPTION` | The name of the request attribute that should be set by the container when custom error-handling servlet or JSP page is invoked.
    `static java.lang.String` | `ERROR_EXCEPTION_TYPE` | The name of the request attribute that should be set by the container when custom error-handling servlet or JSP page is invoked.
    `static java.lang.String` | `ERROR_MESSAGE` | The name of the request attribute that should be set by the container when custom error-handling servlet or JSP page is invoked.
    `static java.lang.String` | `ERROR_REQUEST_URI` | The name of the request attribute that should be set by the container when custom error-handling servlet or JSP page is invoked.
    `static java.lang.String` | `ERROR_SERVLET_NAME` | The name of the request attribute that should be set by the container when custom error-handling servlet or JSP page is invoked.
    `static java.lang.String` | `ERROR_STATUS_CODE` | The name of the request attribute that should be set by the container when custom error-handling servlet or JSP page is invoked.
    `static java.lang.String` | `FORWARD_CONTEXT_PATH` | The name of the request attribute that should be set by the container when the `forward(ServletRequest, ServletResponse)` method is called.
    `static java.lang.String` | `FORWARD_MAPPING` | The name of the request attribute that should be set by the container when the `forward(ServletRequest, ServletResponse)` method is called.
    `static java.lang.String` | `FORWARD_PATH_INFO` | The name of the request attribute that should be set by the container when the `forward(ServletRequest, ServletResponse)` method is called.
    `static java.lang.String` | `FORWARD_QUERY_STRING` | The name of the request attribute that should be set by the container when the `forward(ServletRequest, ServletResponse)` method is called.
    `static java.lang.String` | `FORWARD_REQUEST_URI` | The name of the request attribute that should be set by the container when the `forward(ServletRequest, ServletResponse)` method is called.
    `static java.lang.String` | `FORWARD_SERVLET_PATH` | The name of the request attribute that should be set by the container when the `forward(ServletRequest, ServletResponse)` method is called.
    `static java.lang.String` | `INCLUDE_CONTEXT_PATH` | The name of the request attribute that should be set by the container when the `include(ServletRequest, ServletResponse)` method is called on the `RequestDispatcher` obtained by a path and not by a name.
    `static java.lang.String` | `INCLUDE_MAPPING` | The name of the request attribute that should be set by the container when the `include(ServletRequest, ServletResponse)` method is called on the `RequestDispatcher` obtained by a path and not by a name.
    `static java.lang.String` | `INCLUDE_PATH_INFO` | The name of the request attribute that should be set by the container when the `include(ServletRequest, ServletResponse)` method is called on the `RequestDispatcher` obtained by a path and not by a name.
    `static java.lang.String` | `INCLUDE_QUERY_STRING` | The name of the request attribute that should be set by the container when the `include(ServletRequest, ServletResponse)` method is called on the `RequestDispatcher` obtained by a path and not by a name.
    `static java.lang.String` | `INCLUDE_REQUEST_URI` | The name of the request attribute that should be set by the container when the `include(ServletRequest, ServletResponse)` method is called on the `RequestDispatcher` obtained by a path and not by a name.
    `static java.lang.String` | `INCLUDE_SERVLET_PATH` | The name of the request attribute that should be set by the container when the `include(ServletRequest, ServletResponse)` method is called on the `RequestDispatcher` obtained by a path and not by a name.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `forward​(ServletRequest request, ServletResponse response)` | Forwards a request from a servlet to another resource (servlet, JSP file, or HTML file) on the server.
    `void` | `include​(ServletRequest request, ServletResponse response)` | Includes the content of a resource (servlet, JSP page, HTML file) in the response.

- - ### Field Detail

    - #### FORWARD_REQUEST_URI

          static final java.lang.String FORWARD_REQUEST_URI

      The name of the request attribute that should be set by the container when the `forward(ServletRequest, ServletResponse)` method is called. It provides the original value of a path-related property of the request. See the chapter "Forwarded Request Parameters" in the Servlet Specification for details.
      Since:
        Servlet 3.0
      See Also:
        Constant Field Values

    - #### FORWARD_CONTEXT_PATH

          static final java.lang.String FORWARD_CONTEXT_PATH

      The name of the request attribute that should be set by the container when the `forward(ServletRequest, ServletResponse)` method is called. It provides the original value of a path-related property of the request. See the chapter "Forwarded Request Parameters" in the Servlet Specification for details.
      Since:
        Servlet 3.0
      See Also:
        Constant Field Values

    - #### FORWARD_MAPPING

          static final java.lang.String FORWARD_MAPPING

      The name of the request attribute that should be set by the container when the `forward(ServletRequest, ServletResponse)` method is called. It provides the original value of a path-related property of the request. See the chapter "Forwarded Request Parameters" in the Servlet Specification for details.
      Since:
        Servlet 4.0
      See Also:
        Constant Field Values

    - #### FORWARD_PATH_INFO

          static final java.lang.String FORWARD_PATH_INFO

      The name of the request attribute that should be set by the container when the `forward(ServletRequest, ServletResponse)` method is called. It provides the original value of a path-related property of the request. See the chapter "Forwarded Request Parameters" in the Servlet Specification for details.
      Since:
        Servlet 3.0
      See Also:
        Constant Field Values

    - #### FORWARD_SERVLET_PATH

          static final java.lang.String FORWARD_SERVLET_PATH

      The name of the request attribute that should be set by the container when the `forward(ServletRequest, ServletResponse)` method is called. It provides the original value of a path-related property of the request. See the chapter "Forwarded Request Parameters" in the Servlet Specification for details.
      Since:
        Servlet 3.0
      See Also:
        Constant Field Values

    - #### FORWARD_QUERY_STRING

          static final java.lang.String FORWARD_QUERY_STRING

      The name of the request attribute that should be set by the container when the `forward(ServletRequest, ServletResponse)` method is called. It provides the original value of a path-related property of the request. See the chapter "Forwarded Request Parameters" in the Servlet Specification for details.
      Since:
        Servlet 3.0
      See Also:
        Constant Field Values

    - #### INCLUDE_REQUEST_URI

          static final java.lang.String INCLUDE_REQUEST_URI

      The name of the request attribute that should be set by the container when the `include(ServletRequest, ServletResponse)` method is called on the `RequestDispatcher` obtained by a path and not by a name. It provides information on the path that was used to obtain the `RequestDispatcher` instance for this include call. See the chapter "Included Request Parameters" in the Servlet Specification for details.
      Since:
        Servlet 3.0
      See Also:
        Constant Field Values

    - #### INCLUDE_CONTEXT_PATH

          static final java.lang.String INCLUDE_CONTEXT_PATH

      The name of the request attribute that should be set by the container when the `include(ServletRequest, ServletResponse)` method is called on the `RequestDispatcher` obtained by a path and not by a name. It provides information on the path that was used to obtain the `RequestDispatcher` instance for this include call. See the chapter "Included Request Parameters" in the Servlet Specification for details.
      Since:
        Servlet 3.0
      See Also:
        Constant Field Values

    - #### INCLUDE_PATH_INFO

          static final java.lang.String INCLUDE_PATH_INFO

      The name of the request attribute that should be set by the container when the `include(ServletRequest, ServletResponse)` method is called on the `RequestDispatcher` obtained by a path and not by a name. It provides information on the path that was used to obtain the `RequestDispatcher` instance for this include call. See the chapter "Included Request Parameters" in the Servlet Specification for details.
      Since:
        Servlet 3.0
      See Also:
        Constant Field Values

    - #### INCLUDE_MAPPING

          static final java.lang.String INCLUDE_MAPPING

      The name of the request attribute that should be set by the container when the `include(ServletRequest, ServletResponse)` method is called on the `RequestDispatcher` obtained by a path and not by a name. It provides information on the path that was used to obtain the `RequestDispatcher` instance for this include call. See the chapter "Included Request Parameters" in the Servlet Specification for details.
      Since:
        Servlet 4.0
      See Also:
        Constant Field Values

    - #### INCLUDE_SERVLET_PATH

          static final java.lang.String INCLUDE_SERVLET_PATH

      The name of the request attribute that should be set by the container when the `include(ServletRequest, ServletResponse)` method is called on the `RequestDispatcher` obtained by a path and not by a name. It provides information on the path that was used to obtain the `RequestDispatcher` instance for this include call. See the chapter "Included Request Parameters" in the Servlet Specification for details.
      Since:
        Servlet 3.0
      See Also:
        Constant Field Values

    - #### INCLUDE_QUERY_STRING

          static final java.lang.String INCLUDE_QUERY_STRING

      The name of the request attribute that should be set by the container when the `include(ServletRequest, ServletResponse)` method is called on the `RequestDispatcher` obtained by a path and not by a name. It provides information on the path that was used to obtain the `RequestDispatcher` instance for this include call. See the chapter "Included Request Parameters" in the Servlet Specification for details.
      Since:
        Servlet 3.0
      See Also:
        Constant Field Values

    - #### ERROR_EXCEPTION

          static final java.lang.String ERROR_EXCEPTION

      The name of the request attribute that should be set by the container when custom error-handling servlet or JSP page is invoked. The value of the attribute is of type `java.lang.Throwable`. See the chapter "Error Handling" in the Servlet Specification for details.
      Since:
        Servlet 3.0
      See Also:
        Constant Field Values

    - #### ERROR_EXCEPTION_TYPE

          static final java.lang.String ERROR_EXCEPTION_TYPE

      The name of the request attribute that should be set by the container when custom error-handling servlet or JSP page is invoked. The value of the attribute is of type `java.lang.Class`. See the chapter "Error Handling" in the Servlet Specification for details.
      Since:
        Servlet 3.0
      See Also:
        Constant Field Values

    - #### ERROR_MESSAGE

          static final java.lang.String ERROR_MESSAGE

      The name of the request attribute that should be set by the container when custom error-handling servlet or JSP page is invoked. The value of the attribute is of type `java.lang.String`. See the chapter "Error Handling" in the Servlet Specification for details.
      Since:
        Servlet 3.0
      See Also:
        Constant Field Values

    - #### ERROR_REQUEST_URI

          static final java.lang.String ERROR_REQUEST_URI

      The name of the request attribute that should be set by the container when custom error-handling servlet or JSP page is invoked. The value of the attribute is of type `java.lang.String`. See the chapter "Error Handling" in the Servlet Specification for details.
      Since:
        Servlet 3.0
      See Also:
        Constant Field Values

    - #### ERROR_SERVLET_NAME

          static final java.lang.String ERROR_SERVLET_NAME

      The name of the request attribute that should be set by the container when custom error-handling servlet or JSP page is invoked. The value of the attribute is of type `java.lang.String`. See the chapter "Error Handling" in the Servlet Specification for details.
      Since:
        Servlet 3.0
      See Also:
        Constant Field Values

    - #### ERROR_STATUS_CODE

          static final java.lang.String ERROR_STATUS_CODE

      The name of the request attribute that should be set by the container when custom error-handling servlet or JSP page is invoked. The value of the attribute is of type `java.lang.Integer`. See the chapter "Error Handling" in the Servlet Specification for details.
      Since:
        Servlet 3.0
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### forward

          void forward​(ServletRequest request,
                       ServletResponse response)
                throws ServletException,
                       java.io.IOException

      Forwards a request from a servlet to another resource (servlet, JSP file, or HTML file) on the server. This method allows one servlet to do preliminary processing of a request and another resource to generate the response.

      For a `RequestDispatcher` obtained via `getRequestDispatcher()`, the `ServletRequest` object has its path elements and parameters adjusted to match the path of the target resource.

      `forward` should be called before the response has been committed to the client (before response body output has been flushed). If the response already has been committed, this method throws an `IllegalStateException`. Uncommitted output in the response buffer is automatically cleared before the forward.

      The request and response parameters must be either the same objects as were passed to the calling servlet's service method or be subclasses of the `ServletRequestWrapper` or `ServletResponseWrapper` classes that wrap them.

      Parameters:
        `request` - a `ServletRequest` object that represents the request the client makes of the servlet
        `response` - a `ServletResponse` object that represents the response the servlet returns to the client
      Throws:
        `ServletException` - if the target resource throws this exception
        `java.io.IOException` - if the target resource throws this exception
        `java.lang.IllegalStateException` - if the response was already committed

    - #### include

          void include​(ServletRequest request,
                       ServletResponse response)
                throws ServletException,
                       java.io.IOException

      Includes the content of a resource (servlet, JSP page, HTML file) in the response. In essence, this method enables programmatic server-side includes.

      The `ServletResponse` object has its path elements and parameters remain unchanged from the caller's. The included servlet cannot change the response status code or set headers; any attempt to make a change is ignored.

      The request and response parameters must be either the same objects as were passed to the calling servlet's service method or be subclasses of the `ServletRequestWrapper` or `ServletResponseWrapper` classes that wrap them.

      Parameters:
        `request` - a `ServletRequest` object that contains the client's request
        `response` - a `ServletResponse` object that contains the servlet's response
      Throws:
        `ServletException` - if the included resource throws this exception
        `java.io.IOException` - if the included resource throws this exception